<template>
  <div class="login-container" :style="login_bg_style">
    <el-form ref="loginForm" :model="loginForm" :rules="loginRules" class="login-form" auto-complete="on" label-position="left">
      <el-form-item prop="username">
        <span class="svg-container">
          <svg-icon icon-class="user" />
        </span>
        <el-input
          ref="username"
          v-model="loginForm.username"
          placeholder="Username"
          name="username"
          type="text"
          tabindex="1"
          auto-complete="on"
        />
      </el-form-item>

      <el-form-item prop="password">
        <span class="svg-container">
          <svg-icon icon-class="password" />
        </span>
        <el-input
          :key="passwordType"
          ref="password"
          v-model="loginForm.password"
          :type="passwordType"
          placeholder="Password"
          name="password"
          tabindex="2"
          auto-complete="on"
          @keyup.enter.native="handleLogin"
        />
        <!--        <span class="show-pwd" @click="showPwd">-->
        <!--          <svg-icon :icon-class="passwordType === 'password' ? 'eye' : 'eye-open'" />-->
        <!--        </span>-->
      </el-form-item>

      <el-button :loading="loading" type="primary" style="width:100%;height:37px;line-height:1px;margin-bottom:30px;" @click.native.prevent="handleLogin">登陆</el-button>
    </el-form>
  </div>
</template>

<script>
import {validUsername} from '@/utils/validate'
import {mapGetters} from 'vuex'
import store from '../../store'
export default {
  name: 'Login',
  data() {
    const validateUsername = (rule, value, callback) => {
      if (!validUsername(value)) {
        callback(new Error('Please enter the correct user name'))
      } else {
        callback()
      }
    }
    const validatePassword = (rule, value, callback) => {
      if (value.length < 6) {
        callback(new Error('The password can not be less than 6 digits'))
      } else {
        callback()
      }
    }
    return {
      loginForm: {
        username: '',
        password: ''
      },
      loginRules: {
        /*  username: [{ required: true, trigger: 'blur', validator: validateUsername }],
          password: [{ required: true, trigger: 'blur', validator: validatePassword }]*/
        username: [{ required: true, trigger: 'blur' }],
        password: [{ required: true, trigger: 'blur' }]
      },
      loading: false,
      passwordType: 'password',
      redirect: undefined,
      login_bg_style: {
        backgroundImage: ''
      }
    }
  },
  watch: {
    $route: {
      handler: function(route) {
        this.redirect = route.query && route.query.redirect
      },
      immediate: true
    }
  },
  mounted() {
    this.changeLoginPage()
  },
  computed: {
    ...mapGetters(["gs"])
  },
  methods: {
    changeLoginPage() {
      this.login_bg_style.backgroundImage = 'url(' + require('../../assets/login-null.jpg') + ')'
    },
    showPwd() {
      if (this.passwordType === 'password') {
        this.passwordType = ''
      } else {
        this.passwordType = 'password'
      }
      this.$nextTick(() => {
        this.$refs.password.focus()
      })
    },
    handleLogin() {
      this.$refs.loginForm.validate(valid => {
        if (valid) {
          this.loading = true
          const param = new URLSearchParams()
          param.append('username', this.loginForm.username)
          param.append('password', this.loginForm.password)
          this.$axios.post('/user/login', param,
          ).then((res) => {
            const { data } = res
            // sessionStorage.setItem('token', data)
            document.cookie = "token="+data;
            document.cookie = "user=".concat(this.loginForm.username)
            sessionStorage.setItem('user', this.loginForm.username)
            // if (this.loginForm.username !== 'admin') {
            //   document.cookie = "user=yw"
            // } else {
            //   document.cookie = "user=admin"
            // }
            this.getReportTheme()
            // this.$router.push('/')
            this.loading = false
          }).catch((error) => {
            this.loading = false
          })

          /*    this.$store.dispatch('user/login', this.loginForm).then(() => {
            this.$router.push('/')
            this.loading = false
          }).catch(() => {
            this.loading = false
          })*/
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },
    getReportTheme(){
      this.$axios.get('/dashboard/sysParameterKey/REPORT_THEME').then(res => {
        console.log(res.data.sysValue)
        if(res.data.sysValue === '0'){
          //蓝色
          sessionStorage.setItem('styleSwitch','blue')
          this.$router.push('/')
        }else{
          //白色
          sessionStorage.setItem('styleSwitch','white')
          this.$router.push('/dashboard')
        }
      })
    }
  }
}
</script>

<style lang="scss">
/* 修复input 背景不协调 和光标变色 */
/* Detail see https://github.com/PanJiaChen/vue-element-admin/pull/927 */

$bg:#283443;
$light_gray:#fff;
$cursor: #fff;

@supports (-webkit-mask: none) and (not (cater-color: $cursor)) {
  .login-container .el-input input {
    color: $cursor;
  }
}

/* reset element-ui css */
.login-container {
  .el-input {
    display: inline-block;
    height: 47px;
    width: 85%;

    input {
      background: transparent;
      border: 10px;
      -webkit-appearance: none;
      border-radius: 0px;
      padding: 12px 5px 12px 15px;
      color: $light_gray;
      vertical-align: middle;
      height: 37px;
      caret-color: $cursor;

      &:-webkit-autofill {
        box-shadow: 0 0 0px 1000px $bg inset !important;
        -webkit-text-fill-color: $cursor !important;
      }
    }
  }

  .el-form-item {
    border: 1px solid rgba(255, 255, 255, 0.1);
    background: rgba(0, 0, 0, 0.1);
    border-radius: 5px;
    color: #454545;
  }
}
.el-form-item__content{
  line-height: 28px;
  position: relative;
  /*font-size: 14px;*/
  height: 37px;
}
</style>

<style lang="scss" scoped>
$bg:#2d3a4b;
$dark_gray:#889aa4;
$light_gray:#eee;

.login-container {
  position:fixed;
  top: 0;
  left: 0;
  width:100%;
  height:100%;
  z-index:10;
  zoom: 1;
  background-color: #fff;
  background-repeat: no-repeat;
  background-size: cover;
  -webkit-background-size: cover;
  -o-background-size: cover;
  background-position: bottom;
  /*background-image: url('../../assets/login.jpg');*/

  .login-form {
    position: relative;
    max-width: 100%;
    width: 320px;
    margin: 0 auto;
    top: 52%;
    -webkit-transform: translateY(-50%);
    -moz-transform: translateY(-50%);
    -ms-transform: translateY(-50%);
    -o-transform: translateY(-50%);
    transform: translateY(-50%);
  }

  .tips {
    font-size: 14px;
    color: #fff;
    margin-bottom: 10px;

    span {
      &:first-of-type {
        margin-right: 16px;
      }
    }
  }

  .svg-container {
    padding: 6px 5px 6px 15px;
    color: $dark_gray;
    vertical-align: middle;
    width: 30px;
    display: inline-block;
  }

  .show-pwd {
    position: absolute;
    right: 10px;
    top: 7px;
    font-size: 16px;
    color: $dark_gray;
    cursor: pointer;
    user-select: none;
  }
}
</style>
